/*
$Id: r_const.h,v 1.1.1.1 1998/07/21 10:27:52 rene Exp $
*/
#ifndef F2C_CONST_H
#  define F2C_CONST_H

#define FALSE 0
#define TRUE  1
#define NOTFOUND 100


#define dialogKeyAlterEdit ('a' & 0x1f)
#define dialogKeyDelEob    ('d' & 0x1f)
#define dialogKeyDelChar   ('x' & 0x1f)
#define dialogKeyHelp      ('w' & 0x1f)

#define KEY_return 	13
#define KEY_escape 	27
#define KEY_esc 	27
#define KEY_tab 	9
#define KEY_up 		2000
#define KEY_down 	2001
#define KEY_left 	2002
#define KEY_right 	2003

/*#define KEY_abort 	2004*/
#define KEY_nextpage 	2005
#define KEY_prevpage 	2006
#define KEY_help 	2008
#define KEY_interrupt 	2011	
#define KEY_insert  	2014
#define KEY_delete 	2015
#define KEY_accept  	2016
#define KEY_backspace  	2017
#define KEY_autonext  	2018
#define KEY_taskFocusIn 2019


#define KEY_f1 	3000
#define KEY_f2 	3001
#define KEY_f3 	3002
#define KEY_f4 	3003
#define KEY_f5 	3004
#define KEY_f6 	3005
#define KEY_f7 	3006
#define KEY_f8 	3007
#define KEY_f9 	3008

#define KEY_f10 	3009
#define KEY_f11 	3010
#define KEY_f12 	3011
#define KEY_f13 	3012
#define KEY_f14 	3013
#define KEY_f15 	3014
#define KEY_f16 	3015
#define KEY_f17 	3016
#define KEY_f18 	3017
#define KEY_f19 	3018

#define KEY_f20 	3019
#define KEY_f21 	3020
#define KEY_f22 	3021
#define KEY_f23 	3022
#define KEY_f24 	3023
#define KEY_f25 	3024
#define KEY_f26 	3025
#define KEY_f27 	3026
#define KEY_f28 	3027
#define KEY_f29 	3028

#define KEY_f30 	3029
#define KEY_f31 	3030
#define KEY_f32 	3031
#define KEY_f33 	3032
#define KEY_f34 	3033
#define KEY_f35 	3034
#define KEY_f36 	3035
#define KEY_f37 	3036
#define KEY_f38 	3037
#define KEY_f39 	3038

#define KEY_f40 	3039
#define KEY_f41 	3040
#define KEY_f42 	3041
#define KEY_f43 	3042
#define KEY_f44 	3043
#define KEY_f45 	3044
#define KEY_f46 	3045
#define KEY_f47 	3046
#define KEY_f48 	3047
#define KEY_f49 	3048

#define KEY_f50 	3049
#define KEY_f51 	3050
#define KEY_f52 	3051
#define KEY_f53 	3052
#define KEY_f54 	3053
#define KEY_f55 	3054
#define KEY_f56 	3055
#define KEY_f57 	3056
#define KEY_f58 	3057
#define KEY_f59 	3058

#define KEY_f60 	3059
#define KEY_f61 	3060
#define KEY_f62 	3061
#define KEY_f63 	3062
#define KEY_f64 	3063
#define KEY_f65 	3064
#define KEY_f66 	3065
#define KEY_f67 	3066
#define KEY_f68 	3067
#define KEY_f69 	3068

#define KEY_nextOption  4000
#define KEY_nextField   4001
#define KEY_menuEnter   4002
#define KEY_delchar	4003
#define KEY_arrayGoto	4004
#define KEY_remoteSource 4005
#define KEY_fglOK        4006
#define KEY_buffer       4007


#define colWhite 	0
#define colYellow 	1
#define colMagenta 	2
#define colRed 		3
#define colCyan 	4
#define colGreen 	5
#define colBlue 	6
#define colBlack 	7

#define attrNormal 	0
#define attrBlink 	(1<<3)	/* 0x08 */
#define attrReverse 	(1<<4)	/* 0x10 */
#define attrInverse 	(1<<4)  /* 0x10 */
#define attrUnderline 	(1<<5)	/* 0x20 */
#define attrHighlight 	(1<<6)	/* 0x40 */
#define attrBold 	(1<<6)  /* 0x40 */
#define attrDim 	(1<<7)  /* 0x80 */
#define attrInvisible 	(1<<8)  /* 0x100 */

#define attrWindow	(0x4000)
#define attrForm	(0x2000)

#define attrNull 	((short)0x8000)

#define formDisplayonly (1<<0)
#define formAutonext	(1<<1)
#define formLeft 	(1<<2)
#define formBlankfill	(1<<3)
/* #define formInvisible 	(1<<4) */
#define formRequired	(1<<5)
#define formSecret	(1<<6)
#define formZerofill	(1<<7)
#define formDownshift	(1<<8)
#define formUpshift	(1<<9)
#define formNotNull     (1<<10)
#define formScroll      (1<<11)
#define formWordwrap    (1<<12)
#define formRemoved     (1<<13)
#define formCompress    (1<<14)
#define formVerify      (1<<15)

#define cursorPosNext 		1
#define cursorPosPrevious 	2
#define cursorPosFirst 		3
#define cursorPosLast 		4
#define cursorPosCurrent 	5
#define cursorPosAbsolute 	6	
#define cursorPosRelative 	7	

#define flagWithReoptimization 	1
#define flagWithHold 		1
#define flagScrollYes 		1
#define flagPromptForChar 	1 
#define flagInputWithoutDefaults 1

#define reportOptFile 		0
#define reportOptPipe 		1
#define reportOptPrinter 	2
#define reportOptLeftMargin 	3
#define reportOptRightMargin 	4
#define reportOptTopMargin 	5
#define reportOptBottomMargin 	6
#define reportOptPageLength 	7
#define reportOptTopOfPage      8 
#define reportNeedsSql          9
#define reportTrailerLines     10
#define reportHeaderLines      11
#define reportFirstHeaderLines 12
#define reportNumberAggr       13

#define reportAggrCount 	0
#define reportAggrPercent 	1
#define reportAggrSum 		2
#define reportAggrAvg 		3
#define reportAggrMin 		4
#define reportAggrMax 		5

#define reportOrderDefault 	0
#define reportOrderAsc 		1
#define reportOrderDesc 	2
	
#define reportCmdOutput 	0
#define reportCmdFinish 	1
#define reportCmdStart 		2
#define reportCmdStartToFile 	3
#define reportCmdStartToPipe 	4
#define reportCmdStartToPrinter 5

#define reportEventRegister 	6
#define reportEventRegisterOutput  	7 
#define reportEventRegisterOrder 	8 
#define reportEventRegisterParameter	9 
#define reportEventEvalGlobal 	10 
#define reportEventEvalGroup 	11 
#define reportEventEveryRow 	12
#define reportEventFirstPageHeader 	13
#define reportEventPageHeader 	14
#define reportEventOnEveryRow 	15
#define reportEventPageTrailer 	16
#define reportEventOnLastRow 	17
#define reportEventBeforeGroup  0x100
#define reportEventAfterGroup  	0x200

#define optDiaOut      0
#define optDiaIn       1
#define optDiaSF       2
#define optDiaAttr     3
#define optDiaMode     4
#define optDiaHelp     5

#define MenuBeforeMenu 0
#define MenuCommandKey 1
#define MenuCommand    2
#define MenuCommandAcc 3

#define EventOnKey        0
#define EventBeforeField  1
#define EventBeforeDelete 2
#define EventBeforeDialog 3
#define EventBeforeRow    4
#define EventBeforeInsert 5

#define EventAfterField   6
#define EventAfterDelete  7
#define EventAfterDialog  8
#define EventAfterRow     9
#define EventAfterInsert  10
#define EventMax          11

#define dialogNoop         0
#define dialogDone        -1
/*
#define dialogBeforeDialog 1
#define dialogAfterDialog  2
#define dialogBeforeInsert 3
#define dialogAfterInsert  4
#define dialogBeforeDelete 5
#define dialogAfterDelete  6
#define dialogBeforeRow    7
#define dialogAfterRow     8
#define dialogBeforeField  9
#define dialogAfterField   10
#define dialogRegister     11
#define dialogNextField    12
#define dialogOnkey        13
#define dialogNoop         14
#define dialogDialog 	   1000
*/

#define cursorForSelect 	0
#define cursorForInsert 	1
#define cursorForStmt 		2

#define wndAttrPromptLine 	1
#define wndAttrMenuLine 	2
#define wndAttrCommentLine 	3
#define wndAttrErrorLine 	4
#define wndAttrFormLine 	5
#define wndAttrMessageLine 	6
#define wndAttrColor 	        7
#define wndAttrBorder 	        8
#define wndAttrAttr 	        9

#define optionMessageLine   0
#define optionPromptLine    1
#define optionMenuLine 	    2
#define optionCommentLine   3
#define optionErrorLine     4
#define optionFormLine 	    5
#define optionQueryLine     6
#define optionInsertKey     7
#define optionDeleteKey     8
#define optionNextKey 	    9
#define optionPreviousKey  10
#define optionAcceptKey    11
#define optionHelpKey 	   12
#define optionAbortKey 	   13
#define optionInputWrap    14
#define optionSqlInterrupt 15
#define optionFieldOrder   16
#define optionInputAttr    17
#define optionInputColor   18
#define optionDisplayAttr  19
#define optionDisplayColor 20
#define optionHelpFile 	   21

#define TU_YEAR 	0
#define TU_MONTH 	2
#define TU_DAY 		4
#define TU_HOUR		6
#define TU_MINUTE	8
#define TU_SECOND	10
#define TU_FRAC		12
#define TU_F1		11
#define TU_F2		12
#define TU_F3 		13
#define TU_F4		14
#define TU_F5		15

enum State{
    Normal,
    Active,
    Select
};

#define attrMask  (attrReverse|attrUnderline|attrHighlight|attrBlink|attrDim)
#define highlightMask  (attrHighlight|attrDim)

#endif
